<?php
/**
 * @version   1.2 February 11, 2016
 * @author    RocketTheme http://www.rockettheme.com
 * @copyright Copyright (C) 2007 - 2016 RocketTheme, LLC
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */
defined('GANTRY_VERSION') or die();

gantry_import('core.gantrywidget');

add_action('widgets_init', array("GantryWidgetBreadcrumbs","init"));

class GantryWidgetBreadcrumbs extends GantryWidget {
    var $short_name = 'breadcrumbs';
    var $wp_name = 'gantry_breakcrumbs';
    var $long_name = 'Gantry Breadcrumbs';
    var $description = 'Gantry Breadcrumbs Widget';
    var $css_classname = 'widget_gantry_breadcrumbs';
    var $width = 200;
    var $height = 400;

    function init() {
        register_widget("GantryWidgetBreadcrumbs");
    }

    function render($args, $instance){
        global $gantry, $post;
	    ob_start();
	    
	    ?>
	    
	    <span class="sep">
																	
			<?php
			
			if(!is_home() || !is_front_page()) :
			
			$parent_id  = $post->post_parent;
			$breadcrumbs = array();
			while ($parent_id) {
				$page = get_page($parent_id);
				$breadcrumbs[] = '<a href="'.get_permalink($page->ID).'" class="pathway">'.get_the_title($page->ID).'</a>';
				$parent_id  = $page->post_parent;
			}
			$breadcrumbs = array_reverse($breadcrumbs);
			foreach ($breadcrumbs as $crumb) echo $crumb.'<img alt="" src="'.$gantry->templateUrl.'/images/blank.gif"/>';
			
			?>
			
			<span class="no-link"><?php the_title(); ?></span>
			
			<?php endif; ?>
			
		</span>
		
		<?php
		
		echo ob_get_clean();
	    
	}
}